#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow),
    proc_(this),reproz_("(\\d+)%")
{
    ui->setupUi(this);

    proc_.setProgram("/home/weber/exp/qt5/build_bsptrans/bsptrans");
    connect(&proc_,SIGNAL(started()),this, SLOT(procStarted()));
    connect(&proc_,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(procFinished(int,QProcess::ExitStatus)));
    connect(&proc_,SIGNAL(readyReadStandardOutput()),this,SLOT(procReadStdout()));
    connect(this,SIGNAL(valueChanged(int)),ui->progressBar,SLOT(setValue(int)));
    proc_.setReadChannel(QProcess::StandardOutput);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::procStarted()
{
    qDebug() << "Process started ...";
}

void MainWindow::procFinished(int exitcode,QProcess::ExitStatus exitstatus)
{
    qDebug() << "Process finished exitcode=" << exitcode << " Status=" << exitstatus;
}

void MainWindow::procReadStdout()
{
     char  buffer[1024];
     qint64 length = proc_.readLine(buffer,128);
     if(length > 0)
     {
        QString line(buffer);
        qDebug() << line;
        int pos = reproz_.indexIn(line);
        if(pos > -1)
        {
            QString valuestr = reproz_.cap(1);
            qDebug() << valuestr;
            emit valueChanged(valuestr.toInt());
        }
     }
}


void MainWindow::on_startButton_clicked()
{
    QString errorfile("/tmp/bsptransformer_stderr");
    proc_.setStandardErrorFile(errorfile);
    proc_.start();
    if(!proc_.waitForStarted())
    {
        qDebug() << "start: " << proc_.errorString();
    }
}
